grammar ABE;

options {
   language=JavaScript;
   output=AST; 
}

ruleset   : rule* EOF
;
rule      : subject predicate+ 
		
;
predicate : action method* origin?
;
method    : HTTPVERB | ALL | SUB
;
origin    : (T_FROM resources)
;
subject   : T_SITE resources
;
resources : (resource+ | ALL)
;	
resource  : (REGEXP | GLOB | URI | LOCATION)
;
action    : A_DENY | A_LOGOUT | A_SANDBOX  | A_ACCEPT
;

T_SITE    : 'Site' ;
T_FROM 	  : ('f' | 'F') 'rom' ;
A_DENY    : 'Deny' ;
A_LOGOUT  : 'Logout' ;
A_SANDBOX : 'Sandbox' ;
A_ACCEPT  : 'Accept' ;

fragment URI_START : 'a'..'z'
;
fragment URI_PART  : 'a'..'z' | 'A'..'Z' | '0'..'9' | '_' | '-' | '.' | 
            ':' | '/' | '@' | '~' | ';' | ',' | '?' | '&' | '%' | '#'
;
LOCATION  : 'LOCAL' | 'SELF'	
;
URI       : URI_START URI_PART+
;
GLOB      : (URI_START | '*') (URI_PART | '*')*
;
REGEXP    : '^' ~'\n'+
;
ALL	  : 'ALL'
;
SUB	  : 'SUB'	
;
HTTPVERB  : 'A'..'Z' 'A'..'Z'+
;	

LIST_SEP  : ','
;
WS  :  (' '|'\r'|'\t'|'\u000C'|'\n') {$channel=HIDDEN;}
;
COMMENT : '#' ~'\n'* {$channel=HIDDEN;}
;



		
